#include <bits/stdc++.h>
using namespace std;
int main()
{
    int n, q, rez=0;
    bool cont=false;
    cin>>n>>q;
    int Z[n], I[n], O[q];
    for (int i=0; i<n; i++) cin>>Z[i]>>I[i];
    for (int i=0; i<q; i++) cin>>O[i];
    for (int i=0; i<q; i++)
    {
        rez=0;
        for (int j=0; j<n; j++)
        {
            if (O[i]<Z[j])
            {
                cout<<rez<<"\n";
                cont=true;
                continue;
            }
            else if ((j+1)<n && (Z[j]+I[j])>Z[j+1] && (Z[j]+I[j])<O[i])
                Z[j+1]+=(Z[j]-I[j]+Z[j+1]);
            else if ((j+1)<n && (rez+I[j])>O[i])
            {
                rez+=(I[j]-O[i]);
                cont=true;
                continue;
            }
            else rez+=I[j];
        }
        if (cont==false) cout<<rez<<"\n";
        else cont=false;
    }
    return 0;
}